Index: code/branches/presentation2/data/gui/scripts/NewAudioMenu.lua
===================================================================
--- code/branches/presentation2/data/gui/scripts/NewAudioMenu.lua	(revision 6206)
+++ 	(revision )
@@ -1,42 +1,0 @@
--- NewAudioMenu.lua
-
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-if _REQUIREDNAME == nil then
-    NewAudioMenu = P
-else
-    _G[_REQUIREDNAME] = P
-end
-
-P.filename = "NewAudioMenu"
-P.layoutString = "NewAudioMenu.layout"
-
-function P.AudioMusicScrollbar_clicked(e)
-    -- music volume
-    debug("event: music volume")
-end
-
-function P.AudioSoundScrollbar_clicked(e)
-    -- sound volume
-    debug("event: sound volume")
-end
-
-function P.AudioMuteMusicCheckbox_clicked(e)
-    soundMgr = orxonox.SoundManager:getInstance()
-    soundMgr:toggleMute(orxonox.SoundType.ambient)
-    debug("event: mute music")
-end
-
-function P.AudioMuteSoundCheckbox_clicked(e)
-    soundMgr = orxonox.SoundManager:getInstance()
-    soundMgr:toggleMute(orxonox.SoundType.none)
-    debug("event: mute sound")
-end
-
-function P.AudioBackButton_clicked(e)
-    hideGUI("NewAudioMenu")
-    debug("event: back")
-end
-
-return P
-
Index: code/branches/presentation2/data/gui/scripts/NewControlsMenu.lua
===================================================================
--- code/branches/presentation2/data/gui/scripts/NewControlsMenu.lua	(revision 6206)
+++ 	(revision )
@@ -1,30 +1,0 @@
--- NewControlsMenu.lua
-
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-if _REQUIREDNAME == nil then
-    NewControlsMenu = P
-else
-    _G[_REQUIREDNAME] = P
-end
-
-P.filename = "NewControlsMenu"
-P.layoutString = "NewControlsMenu.layout"
-
-function P.ControlsMouseControlsButton_clicked(e)
-    showGUI("NewMouseControlsMenu")
-    debug("event: MOUSE CONTROLS")
-end
-
-function P.ControlsKeyboardControlsButton_clicked(e)
-    showGUI("NewKeyboardControlsMenu")
-    debug("event: KEYBOARD CONTROLS")
-end
-
-function P.ControlsBackButton_clicked(e)
-    hideGUI("NewControlsMenu")
-    debug("event: back")
-end
-
-return P
-
Index: code/branches/presentation2/data/gui/scripts/NewCreditsMenu.lua
===================================================================
--- code/branches/presentation2/data/gui/scripts/NewCreditsMenu.lua	(revision 6206)
+++ 	(revision )
@@ -1,20 +1,0 @@
--- NewCreditsMenu.lua
-
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-if _REQUIREDNAME == nil then
-    NewCreditsMenu = P
-else
-    _G[_REQUIREDNAME] = P
-end
-
-P.filename = "NewCreditsMenu"
-P.layoutString = "NewCreditsMenu.layout"
-
-function P.CreditsBackButton_clicked(e)
-    hideGUI("NewCreditsMenu")
-    debug("event: back")
-end
-
-return P
-
Index: code/branches/presentation2/data/gui/scripts/NewGameplayMenu.lua
===================================================================
--- code/branches/presentation2/data/gui/scripts/NewGameplayMenu.lua	(revision 6206)
+++ 	(revision )
@@ -1,61 +1,0 @@
--- NewGameplayMenu.lua
-
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-if _REQUIREDNAME == nil then
-    NewGameplayMenu = P
-else
-    _G[_REQUIREDNAME] = P
-end
-
-P.filename = "NewGameplayMenu"
-P.layoutString = "NewGameplayMenu.layout"
-
-function P:init()
-    dropdown = winMgr:getWindow("orxonox/ThemeCombobox")
-    preselect = orxonox.LevelManager:getInstance():getDefaultLevel()
-    orxonox.LevelManager:getInstance():compileAvailableLevelList()
-    local levelList = {}
-    local index = 0
-    local level = ""
-    while true do
-      level = orxonox.LevelManager:getInstance():getAvailableLevelListItem(index)
-      if level == "" then
-        break
-      end
-      table.insert(levelList, level)
-      index = index + 1
-    end
-    table.sort(levelList)
-    for k,v in pairs(levelList) do
-        item = CEGUI.createListboxTextItem(v)        
-        item:setSelectionBrushImage("TaharezLook", "MultiListSelectionBrush")
-        CEGUI.toCombobox(dropdown):addItem(item)
-        if v .. ".oxw" == preselect then
-            dropdown:setItemSelectState(item, true)
-        end
-    end
-end
-
-function P.GameplayDifficultyEasyButton_clicked(e)
-    -- difficulty easy
-    debug("event: easy")
-end
-
-function P.GameplayDifficultyNormalButton_clicked(e)
-    -- difficulty normal
-    debug("event: normal")
-end
-
-function P.GameplayDifficultyHardButton_clicked(e)
-    -- difficulty hard
-    debug("event: hard")
-end
-
-function P.GameplayBackButton_clicked(e)
-    hideGUI("NewGameplayMenu")
-    debug("event: back")
-end
-
-return P
-
Index: code/branches/presentation2/data/gui/scripts/NewGraphicsMenu.lua
===================================================================
--- code/branches/presentation2/data/gui/scripts/NewGraphicsMenu.lua	(revision 6206)
+++ 	(revision )
@@ -1,56 +1,0 @@
--- NewGraphicsMenu.lua
-
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-if _REQUIREDNAME == nil then
-    NewGraphicsMenu = P
-else
-    _G[_REQUIREDNAME] = P
-end
-
-P.filename = "NewGraphicsMenu"
-P.layoutString = "NewGraphicsMenu.layout"
-
-function P:init()
-    dropdown = winMgr:getWindow("orxonox/ResolutionCombobox")
-    preselect = orxonox.LevelManager:getInstance():getDefaultLevel()
-    orxonox.LevelManager:getInstance():compileAvailableLevelList()
-    local levelList = {}
-    local index = 0
-    local level = ""
-    while true do
-      level = orxonox.LevelManager:getInstance():getAvailableLevelListItem(index)
-      if level == "" then
-        break
-      end
-      table.insert(levelList, level)
-      index = index + 1
-    end
-    table.sort(levelList)
-    for k,v in pairs(levelList) do
-        item = CEGUI.createListboxTextItem(v)        
-        item:setSelectionBrushImage("TaharezLook", "MultiListSelectionBrush")
-        CEGUI.toCombobox(dropdown):addItem(item)
-        if v .. ".oxw" == preselect then
-            dropdown:setItemSelectState(item, true)
-        end
-    end
-end
-
-function P.GraphicsFullscreenCheckbox_clicked(e)
-    -- fullscreen
-    debug("event: fullscreen")
-end
-
-function P.GraphicsBrightnessScrollbar_clicked(e)
-    -- brightness
-    debug("event: brightness")
-end
-
-function P.GraphicsBackButton_clicked(e)
-    hideGUI("NewGraphicsMenu")
-    debug("event: back")
-end
-
-return P
-
Index: code/branches/presentation2/data/gui/scripts/NewMainMenu.lua
===================================================================
--- code/branches/presentation2/data/gui/scripts/NewMainMenu.lua	(revision 6206)
+++ 	(revision )
@@ -1,46 +1,0 @@
--- NewMainMenu.lua
-
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-if _REQUIREDNAME == nil then
-    NewMainMenu = P
-else
-    _G[_REQUIREDNAME] = P
-end
-
-P.filename = "NewMainMenu"
-P.layoutString = "NewMainMenu.layout"
-
--- events for NewMainMenu
-function P.QuickGameTestButton_clicked(e)
-    orxonox.CommandExecutor:execute("startGame")
-    debug("event: quick game test")
-end
-
-function P.SingleplayerButton_clicked(e)
-    showGUI("NewSingleplayerMenu")
-    debug("event: SINGLEPLAYER")
-end
-
-function P.MultiplayerButton_clicked(e)
-    showGUI("NewMultiplayerMenu")
-    debug("event: MULTIPLAYER")
-end
-
-function P.SettingsButton_clicked(e)
-    showGUI("NewSettingsMenu")
-    debug("event: SETTINGS")
-end
-
-function P.CreditsButton_clicked(e)
-    showGUI("NewCreditsMenu")
-    debug("event: CREDITS")
-end
-
-function P.ExitButton_clicked(e)
-    orxonox.CommandExecutor:execute("exit")
-    debug("event: exit")
-end
-
-return P
-
Index: code/branches/presentation2/data/gui/scripts/NewMouseControlsMenu.lua
===================================================================
--- code/branches/presentation2/data/gui/scripts/NewMouseControlsMenu.lua	(revision 6206)
+++ 	(revision )
@@ -1,35 +1,0 @@
--- NewMouseControlsMenu.lua
-
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-if _REQUIREDNAME == nil then
-    NewMouseControlsMenu = P
-else
-    _G[_REQUIREDNAME] = P
-end
-
-P.filename = "NewMouseControlsMenu"
-P.layoutString = "NewMouseControlsMenu.layout"
-
-function P.MouseControlsMouseScrollbar_clicked(e)
-    -- mouse sensitivity
-    debug("event: mouse sensitivity")
-end
-
-function P.MouseControlsDefaultButton_clicked(e)
-    -- default control mode
-    debug("event: default control mode")
-end
-
-function P.MouseControls_______Button_clicked(e)
-    -- .......
-    debug("event: .......")
-end
-
-function P.MouseControlsBackButton_clicked(e)
-    hideGUI("NewMouseControlsMenu")
-    debug("event: back")
-end
-
-return P
-
Index: code/branches/presentation2/data/gui/scripts/NewMultiplayerMenu.lua
===================================================================
--- code/branches/presentation2/data/gui/scripts/NewMultiplayerMenu.lua	(revision 6206)
+++ 	(revision )
@@ -1,87 +1,0 @@
--- NewMultiplayerMenu.lua
-
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-if _REQUIREDNAME == nil then
-    NewMultiplayerMenu = P
-else
-    _G[_REQUIREDNAME] = P
-end
-
-P.filename = "NewMultiplayerMenu"
-P.layoutString = "NewMultiplayerMenu.layout"
-
-function P:init()
-    listbox = winMgr:getWindow("orxonox/MultiplayerLevelListbox")
-    preselect = orxonox.LevelManager:getInstance():getDefaultLevel()
-    orxonox.LevelManager:getInstance():compileAvailableLevelList()
-    local levelList = {}
-    local index = 0
-    local level = ""
-    while true do
-        level = orxonox.LevelManager:getInstance():getAvailableLevelListItem(index)
-        if level == "" then
-            break
-        end
-        table.insert(levelList, level)
-        index = index + 1
-    end
-    table.sort(levelList)
-    for k,v in pairs(levelList) do
-        item = CEGUI.createListboxTextItem(v)        
-        item:setSelectionBrushImage("TaharezLook", "MultiListSelectionBrush")
-        CEGUI.toListbox(listbox):addItem(item)
-        if v .. ".oxw" == preselect then
-            listbox:setItemSelectState(item, true)
-        end
-    end
-    local multiplayerMode = "startClient"
-    if multiplayerMode == "startClient" then
-        window = winMgr:getWindow("orxonox/MultiplayerJoinButton")
-        button = tolua.cast(window,"CEGUI::RadioButton")
-        button:setSelected(true)
-    end
-    if multiplayerMode == "startServer" then
-        window = winMgr:getWindow("orxonox/MultiplayerHostButton")
-        button = tolua.cast(window,"CEGUI::RadioButton")
-        button:setSelected(true)
-    end
-    if multiplayerMode == "startDedicated" then
-        window = winMgr:getWindow("orxonox/MultiplayerDedicatedButton")
-        button = tolua.cast(window,"CEGUI::RadioButton")
-        button:setSelected(true)
-    end
-end
-
-function P.MultiplayerJoinButton_clicked(e)
-    multiplayerMode = "startClient"
-    debug("event: join")
-end
-
-function P.MultiplayerHostButton_clicked(e)
-    multiplayerMode = "startServer"
-    debug("event: host")
-end
-
-function P.MultiplayerDedicatedButton_clicked(e)
-    multiplayerMode = "startDedicated"
-    debug("event: dedicated")
-end
-
-function P.MultiplayerStartButton_clicked(e)
-    local choice = winMgr:getWindow("orxonox/MultiplayerLevelListbox"):getFirstSelectedItem()
-    if choice then
-        orxonox.LevelManager:getInstance():setDefaultLevel(choice:getText() .. ".oxw")
-        orxonox.CommandExecutor:execute(multiplayerMode)
-        hideAllGUIs()
-        debug("event: start")
-    end
-end
-
-function P.MultiplayerBackButton_clicked(e)
-    hideGUI("NewMultiplayerMenu")
-    debug("event: back")
-end
-
-return P
-
Index: code/branches/presentation2/data/gui/scripts/NewSettingsMenu.lua
===================================================================
--- code/branches/presentation2/data/gui/scripts/NewSettingsMenu.lua	(revision 6206)
+++ 	(revision )
@@ -1,50 +1,0 @@
--- NewSettingsMenu.lua
-
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-if _REQUIREDNAME == nil then
-    NewSettingsMenu = P
-else
-    _G[_REQUIREDNAME] = P
-end
-
-P.filename = "NewSettingsMenu"
-P.layoutString = "NewSettingsMenu.layout"
-
-function P.SettingsGameplayButton_clicked(e)
-    showGUI("NewGameplayMenu")
-    debug("event: GAMEPLAY")
-end
-
-function P.SettingsMultiplayerOptionsButton_clicked(e)
-    showGUI("NewMultiplayerOptionsMenu")
-    debug("event: MULTIPLAYER OPTIONS")
-end
-
-function P.SettingsControlsButton_clicked(e)
-    showGUI("NewControlsMenu")
-    debug("event: CONTROLS")
-end
-
-function P.SettingsGraphicsButton_clicked(e)
-    showGUI("NewGraphicsMenu")
-    debug("event: GRAPHICS")
-end
-
-function P.SettingsAudioButton_clicked(e)
-    showGUI("NewAudioMenu")
-    debug("event: AUDIO")
-end
-
-function P.SettingsResetSettingsButton_clicked(e)
-    -- reset settings
-    debug("event: reset settings")
-end
-
-function P.SettingsBackButton_clicked(e)
-    hideGUI("NewSettingsMenu")
-    debug("event: back")
-end
-
-return P
-
Index: code/branches/presentation2/data/gui/scripts/NewSingleplayerMenu.lua
===================================================================
--- code/branches/presentation2/data/gui/scripts/NewSingleplayerMenu.lua	(revision 6206)
+++ 	(revision )
@@ -1,56 +1,0 @@
--- NewSingleplayerMenu.lua
-
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-if _REQUIREDNAME == nil then
-    NewSingleplayerMenu = P
-else
-    _G[_REQUIREDNAME] = P
-end
-
-P.filename = "NewSingleplayerMenu"
-P.layoutString = "NewSingleplayerMenu.layout"
-
-function P:init()
-    listbox = winMgr:getWindow("orxonox/SingleplayerLevelListbox")
-    preselect = orxonox.LevelManager:getInstance():getDefaultLevel()
-    orxonox.LevelManager:getInstance():compileAvailableLevelList()
-    local levelList = {}
-    local index = 0
-    local level = ""
-    while true do
-      level = orxonox.LevelManager:getInstance():getAvailableLevelListItem(index)
-      if level == "" then
-        break
-      end
-      table.insert(levelList, level)
-      index = index + 1
-    end
-    table.sort(levelList)
-    for k,v in pairs(levelList) do
-        item = CEGUI.createListboxTextItem(v)        
-        item:setSelectionBrushImage("TaharezLook", "MultiListSelectionBrush")
-        CEGUI.toListbox(listbox):addItem(item)
-        if v .. ".oxw" == preselect then
-            listbox:setItemSelectState(item, true)
-        end
-    end
-end
-
-function P.SingleplayerStartButton_clicked(e)
-    choice = winMgr:getWindow("orxonox/SingleplayerLevelListbox"):getFirstSelectedItem()
-    if choice then
-        orxonox.LevelManager:getInstance():setDefaultLevel(choice:getText() .. ".oxw")
-        orxonox.CommandExecutor:execute("startGame")
-        hideAllGUIs()
-        debug("event: start")
-    end
-end
-
-function P.SingleplayerBackButton_clicked(e)
-    hideGUI("NewSingleplayerMenu")
-    debug("event: back")
-end
-
-return P
-