Index: code/branches/presentation2/data/gui/layouts/DecisionPopup.layout
===================================================================
--- code/branches/presentation2/data/gui/layouts/DecisionPopup.layout	(revision 6216)
+++ code/branches/presentation2/data/gui/layouts/DecisionPopup.layout	(revision 6217)
@@ -9,5 +9,5 @@
             <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
             <Property Name="UnifiedAreaRect" Value="{{0,0},{0,0},{1,0},{1,0}}" />
-            <Property Name="Alpha" Value="0.5" />
+            <Property Name="Alpha" Value="0.6" />
             <Window Type="TaharezLook/Button" Name="orxonox/DecisionPopup_button_yes" >
                 <Property Name="Font" Value="BlueHighway-12" />
Index: code/branches/presentation2/data/gui/layouts/InGameMenu.layout
===================================================================
--- code/branches/presentation2/data/gui/layouts/InGameMenu.layout	(revision 6216)
+++ code/branches/presentation2/data/gui/layouts/InGameMenu.layout	(revision 6217)
@@ -6,11 +6,27 @@
         <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
         <Property Name="UnifiedAreaRect" Value="{{0,0},{0,0},{1,0},{1,0}}" />
+        <Window Type="TaharezLook/Button" Name="orxonox/InGameMenu_ReturnButton" >
+            <Property Name="Font" Value="BlueHighway-12" />
+            <Property Name="Text" Value="Return to Game" />
+            <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
+            <Property Name="UnifiedAreaRect" Value="{{0.4,0},{0.3,0},{0.6,0},{0.36,0}}" />
+            <Property Name="Alpha" Value="0.7" />
+            <Event Name="Clicked" Function="InGameMenu.button_return_clicked"/>
+        </Window>
         <Window Type="TaharezLook/Button" Name="orxonox/InGameMenu_MainMenuButton" >
             <Property Name="Font" Value="BlueHighway-12" />
-            <Property Name="Text" Value="MainMenu" />
+            <Property Name="Text" Value="Main Menu" />
             <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-            <Property Name="UnifiedAreaRect" Value="{{0.4,0},{0.2,0},{0.6,0},{0.3,0}}" />
+            <Property Name="UnifiedAreaRect" Value="{{0.4,0},{0.4,0},{0.6,0},{0.46,0}}" />
             <Property Name="Alpha" Value="0.7" />
             <Event Name="Clicked" Function="InGameMenu.button_mainmenu_clicked"/>
+        </Window>
+        <Window Type="TaharezLook/Button" Name="orxonox/InGameMenu_SettingsButton" >
+            <Property Name="Font" Value="BlueHighway-12" />
+            <Property Name="Text" Value="Settings" />
+            <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
+            <Property Name="UnifiedAreaRect" Value="{{0.4,0},{0.5,0},{0.6,0},{0.56,0}}" />
+            <Property Name="Alpha" Value="0.7" />
+            <Event Name="Clicked" Function="InGameMenu.button_settings_clicked"/>
         </Window>
         <Window Type="TaharezLook/Button" Name="orxonox/InGameMenu_QuitButton" >
@@ -18,16 +34,8 @@
             <Property Name="Text" Value="Quit" />
             <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-            <Property Name="UnifiedAreaRect" Value="{{0.4,0},{0.4,0},{0.6,0},{0.5,0}}" />
+            <Property Name="UnifiedAreaRect" Value="{{0.4,0},{0.6,0},{0.6,0},{0.66,0}}" />
             <Property Name="Alpha" Value="0.7" />
             <Event Name="Clicked" Function="InGameMenu.button_quit_clicked"/>
         </Window>
-        <Window Type="TaharezLook/Button" Name="orxonox/InGameMenu_ReturnButton" >
-            <Property Name="Font" Value="BlueHighway-12" />
-            <Property Name="Text" Value="return to Game" />
-            <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-            <Property Name="UnifiedAreaRect" Value="{{0.4,0},{0.6,0},{0.6,0},{0.7,0}}" />
-            <Property Name="Alpha" Value="0.7" />
-            <Event Name="Clicked" Function="InGameMenu.button_return_clicked"/>
-        </Window>
     </Window>
 </GUILayout>
Index: code/branches/presentation2/data/gui/layouts/MainMenu.layout
===================================================================
--- code/branches/presentation2/data/gui/layouts/MainMenu.layout	(revision 6216)
+++ code/branches/presentation2/data/gui/layouts/MainMenu.layout	(revision 6217)
@@ -9,5 +9,5 @@
         <Property Name="BackgroundEnabled" Value="False" />
         <Window Type="TaharezLook/Button" Name="orxonox/QuickGameTestButton" >
-            <Property Name="Text" Value="QUICK GAME TEST" />
+            <Property Name="Text" Value="Quickstart" />
             <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
             <Property Name="UnifiedAreaRect" Value="{{0.4,0},{0.25,0},{0.6,0},{0.3,0}}" />
Index: code/branches/presentation2/data/gui/scripts/InGameMenu.lua
===================================================================
--- code/branches/presentation2/data/gui/scripts/InGameMenu.lua	(revision 6216)
+++ code/branches/presentation2/data/gui/scripts/InGameMenu.lua	(revision 6217)
@@ -25,14 +25,18 @@
     orxonox.Game:getInstance():popState()
     orxonox.Game:getInstance():requestState("mainmenu")
-    orxonox.CommandExecutor:execute("hideGUI InGameMenu")
+    hideGUI("InGameMenu")
+end
+
+function P.button_settings_clicked(e)
+    showGUI("SettingsMenu", true)
 end
 
 function P.button_return_clicked(e)
-    orxonox.CommandExecutor:execute("hideGUI InGameMenu")
+    hideGUI("InGameMenu")
 end
 
 function P.callback(doExit)
     if doExit then
-        orxonox.CommandExecutor:execute("hideGUI InGameMenu")
+        hideGUI("InGameMenu")
         orxonox.CommandExecutor:execute("exit")
     end