Index: code/branches/presentation2/src/libraries/core/ConfigValueContainer.h
===================================================================
--- code/branches/presentation2/src/libraries/core/ConfigValueContainer.h	(revision 6217)
+++ code/branches/presentation2/src/libraries/core/ConfigValueContainer.h	(revision 6218)
@@ -146,10 +146,7 @@
                 if ((this->callback_ && object) || this->bContainerIsNew_)
                 {
-                    if (this->bContainerIsNew_)
-                        this->bContainerIsNew_ = false;
-
                     T temp = *value;
                     this->value_.getValue(value);
-                    if ((*value) != temp)
+                    if (this->bContainerIsNew_ || (*value) != temp)
                     {
                         if (this->callback_ && object)
@@ -158,4 +155,7 @@
                             this->bDoInitialCallback_ = true;
                     }
+
+                    if (this->bContainerIsNew_)
+                        this->bContainerIsNew_ = false;
                 }
                 else
Index: code/branches/presentation2/src/libraries/tools/ParticleInterface.cc
===================================================================
--- code/branches/presentation2/src/libraries/tools/ParticleInterface.cc	(revision 6217)
+++ code/branches/presentation2/src/libraries/tools/ParticleInterface.cc	(revision 6218)
@@ -64,4 +64,6 @@
         this->bAllowedByLOD_ = true;
         this->speedFactor_ = 1.0f;
+
+        this->setDetailLevel(static_cast<unsigned int>(detaillevel));
 
         this->setConfigValues();
@@ -80,6 +82,4 @@
             }
         }
-
-        this->setDetailLevel(static_cast<unsigned int>(detaillevel));
     }
 
Index: code/branches/presentation2/src/libraries/tools/Shader.cc
===================================================================
--- code/branches/presentation2/src/libraries/tools/Shader.cc	(revision 6217)
+++ code/branches/presentation2/src/libraries/tools/Shader.cc	(revision 6218)
@@ -79,6 +79,5 @@
     Shader::~Shader()
     {
-
-        if (this->bLoadCompositor_ && this->compositorInstance_)
+        if (this->compositorInstance_ && this->bLoadCompositor_)
         {
             Ogre::Viewport* viewport = GraphicsManager::getInstance().getViewport();
Index: code/branches/presentation2/src/modules/overlays/hud/HUDBar.cc
===================================================================
--- code/branches/presentation2/src/modules/overlays/hud/HUDBar.cc	(revision 6217)
+++ code/branches/presentation2/src/modules/overlays/hud/HUDBar.cc	(revision 6218)
@@ -85,7 +85,7 @@
 
         this->value_ = 1.0f;  // initielize with 1.0f to trigger a change when calling setValue(0.0f) on the line below
+        this->setAutoColour(true);
         this->setValue(0.0f); // <--
         this->setRightToLeft(false);
-        this->setAutoColour(true);
         this->currentColour_ = ColourValue::White;
 
Index: code/branches/presentation2/src/orxonox/interfaces/RadarViewable.cc
===================================================================
--- code/branches/presentation2/src/orxonox/interfaces/RadarViewable.cc	(revision 6217)
+++ code/branches/presentation2/src/orxonox/interfaces/RadarViewable.cc	(revision 6218)
@@ -51,4 +51,6 @@
         , line_(NULL)
         , LineNode_(NULL)
+        , isHumanShip_(false)
+        , bVisibility_(false)
         , radarObjectCamouflage_(0.0f)
         , radarObjectShape_(Dot)
@@ -56,7 +58,4 @@
     {
         RegisterRootObject(RadarViewable);
-
-        this->bVisibility_ = true;
-        this->isHumanShip_ = false;
 
         this->uniqueId_=getUniqueNumberString();
Index: code/branches/presentation2/src/orxonox/overlays/Map.cc
===================================================================
--- code/branches/presentation2/src/orxonox/overlays/Map.cc	(revision 6217)
+++ code/branches/presentation2/src/orxonox/overlays/Map.cc	(revision 6218)
@@ -94,9 +94,6 @@
 
         //Getting Scene Manager (Hack)
-        if( !sManager_ )
-        {
-            ObjectList<Scene>::iterator it = ObjectList<Scene>::begin();
-            this->sManager_ = it->getSceneManager();
-        }
+        ObjectList<Scene>::iterator it = ObjectList<Scene>::begin();
+        this->sManager_ = it->getSceneManager();
         if( !Map::getMapSceneManager() )
         {
Index: code/branches/presentation2/src/orxonox/overlays/OrxonoxOverlay.cc
===================================================================
--- code/branches/presentation2/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 6217)
+++ code/branches/presentation2/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 6218)
@@ -83,13 +83,13 @@
         // Get aspect ratio from the render window. Later on, we get informed automatically
         this->windowAspectRatio_ = static_cast<float>(this->getWindowWidth()) / this->getWindowHeight();
-        this->sizeCorrectionChanged();
-
-        this->changedVisibility();
-
-        setSize(Vector2(1.0f, 1.0f));
-        setPickPoint(Vector2(0.0f, 0.0f));
-        setPosition(Vector2(0.0f, 0.0f));
-        setRotation(Degree(0.0));
-        setAspectCorrection(false);
+
+        this->size_ = Vector2(1.0f, 1.0f);
+        this->pickPoint_= Vector2(0.0f, 0.0f);
+        this->position_ = Vector2(0.0f, 0.0f);
+        this->angle_ = Degree(0.0);
+        this->bCorrectAspect_ = false;
+        this->rotState_ = Horizontal;
+        this->angleChanged(); // updates all other values as well
+
         setBackgroundMaterial("");
     }